/*
 * Mattermost API Reference
 *
 * There is also a work-in-progress [Postman API reference](https://documenter.getpostman.com/view/4508214/RW8FERUn).
 *
 * The version of the OpenAPI document: 4.0.0
 * Contact: feedback@mattermost.com
 * Generated by: https://openapi-generator.tech
 */

use reqwest;

use super::{configuration, Error};
use super::ResponseContent;

/// struct for passing parameters to the method [`get_thread_mention_counts_by_channel`]
#[derive(Clone, Debug, Default)]
pub struct GetThreadMentionCountsByChannelParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
}

/// struct for passing parameters to the method [`get_user_thread`]
#[derive(Clone, Debug, Default)]
pub struct GetUserThreadParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
    /// The ID of the thread to follow
    pub thread_id: String,
}

/// struct for passing parameters to the method [`get_user_threads`]
#[derive(Clone, Debug, Default)]
pub struct GetUserThreadsParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
    /// Since filters the threads based on their LastUpdateAt timestamp.
    pub since: Option<i32>,
    /// Deleted will specify that even deleted threads should be returned (For mobile sync).
    pub deleted: Option<bool>,
    /// Extended will enrich the response with participant details.
    pub extended: Option<bool>,
    /// Page specifies which part of the results to return, by PageSize.
    pub page: Option<i32>,
    /// PageSize specifies the size of the returned chunk of results.
    pub page_size: Option<i32>,
    /// Setting this to true will only return the total counts.
    pub totals_only: Option<bool>,
    /// Setting this to true will only return threads.
    pub threads_only: Option<bool>,
}

/// struct for passing parameters to the method [`set_thread_unread_by_post_id`]
#[derive(Clone, Debug, Default)]
pub struct SetThreadUnreadByPostIdParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
    /// The ID of the thread to update
    pub thread_id: String,
    /// The ID of a post belonging to the thread to mark as unread.
    pub post_id: String,
}

/// struct for passing parameters to the method [`start_following_thread`]
#[derive(Clone, Debug, Default)]
pub struct StartFollowingThreadParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
    /// The ID of the thread to follow
    pub thread_id: String,
}

/// struct for passing parameters to the method [`stop_following_thread`]
#[derive(Clone, Debug, Default)]
pub struct StopFollowingThreadParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
    /// The ID of the thread to update
    pub thread_id: String,
}

/// struct for passing parameters to the method [`update_thread_read_for_user`]
#[derive(Clone, Debug, Default)]
pub struct UpdateThreadReadForUserParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
    /// The ID of the thread to update
    pub thread_id: String,
    /// The timestamp to which the thread's \"last read\" state will be reset.
    pub timestamp: String,
}

/// struct for passing parameters to the method [`update_threads_read_for_user`]
#[derive(Clone, Debug, Default)]
pub struct UpdateThreadsReadForUserParams {
    /// The ID of the user. This can also be \"me\" which will point to the current user.
    pub user_id: String,
    /// The ID of the team in which the thread is.
    pub team_id: String,
}

/// struct for typed errors of method [`get_thread_mention_counts_by_channel`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetThreadMentionCountsByChannelError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_user_thread`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetUserThreadError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`get_user_threads`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum GetUserThreadsError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`set_thread_unread_by_post_id`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum SetThreadUnreadByPostIdError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`start_following_thread`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum StartFollowingThreadError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`stop_following_thread`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum StopFollowingThreadError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`update_thread_read_for_user`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum UpdateThreadReadForUserError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`update_threads_read_for_user`]
#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
#[serde(untagged)]
pub enum UpdateThreadsReadForUserError {
    Status400(crate::openapi::models::AppError),
    Status401(crate::openapi::models::AppError),
    Status404(crate::openapi::models::AppError),
    UnknownValue(serde_json::Value),
}

/// Get all unread mention counts from followed threads  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn get_thread_mention_counts_by_channel(
    configuration: &configuration::Configuration,
    params: GetThreadMentionCountsByChannelParams,
) -> Result<(), Error<GetThreadMentionCountsByChannelError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/mention_counts",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<GetThreadMentionCountsByChannelError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Get a thread  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn get_user_thread(
    configuration: &configuration::Configuration,
    params: GetUserThreadParams,
) -> Result<(), Error<GetUserThreadError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;
    let thread_id = params.thread_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/{thread_id}",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id),
        thread_id = super::urlencode(thread_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<GetUserThreadError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Get all threads that user is following  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn get_user_threads(
    configuration: &configuration::Configuration,
    params: GetUserThreadsParams,
) -> Result<crate::openapi::models::UserThreads, Error<GetUserThreadsError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;
    let since = params.since;
    let deleted = params.deleted;
    let extended = params.extended;
    let page = params.page;
    let page_size = params.page_size;
    let totals_only = params.totals_only;
    let threads_only = params.threads_only;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = since {
        local_var_req_builder =
            local_var_req_builder.query(&[("since", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = deleted {
        local_var_req_builder =
            local_var_req_builder.query(&[("deleted", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = extended {
        local_var_req_builder =
            local_var_req_builder.query(&[("extended", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = page {
        local_var_req_builder =
            local_var_req_builder.query(&[("page", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = page_size {
        local_var_req_builder =
            local_var_req_builder.query(&[("pageSize", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = totals_only {
        local_var_req_builder =
            local_var_req_builder.query(&[("totalsOnly", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = threads_only {
        local_var_req_builder =
            local_var_req_builder.query(&[("threadsOnly", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetUserThreadsError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Mark a thread that user is following as unread  __Minimum server version__: 6.7  ##### Permissions Must have `read_channel` permission for the channel the thread is in or if the channel is public, have the `read_public_channels` permission for the team.  Must have `edit_other_users` permission if the user is not the one marking the thread for himself.
pub async fn set_thread_unread_by_post_id(
    configuration: &configuration::Configuration,
    params: SetThreadUnreadByPostIdParams,
) -> Result<(), Error<SetThreadUnreadByPostIdError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;
    let thread_id = params.thread_id;
    let post_id = params.post_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/{thread_id}/set_unread/{post_id}",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id),
        thread_id = super::urlencode(thread_id),
        post_id = super::urlencode(post_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::PUT, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<SetThreadUnreadByPostIdError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Start following a thread  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn start_following_thread(
    configuration: &configuration::Configuration,
    params: StartFollowingThreadParams,
) -> Result<(), Error<StartFollowingThreadError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;
    let thread_id = params.thread_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/{thread_id}/following",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id),
        thread_id = super::urlencode(thread_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::PUT, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<StartFollowingThreadError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Stop following a thread  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn stop_following_thread(
    configuration: &configuration::Configuration,
    params: StopFollowingThreadParams,
) -> Result<(), Error<StopFollowingThreadError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;
    let thread_id = params.thread_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/{thread_id}/following",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id),
        thread_id = super::urlencode(thread_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::DELETE, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<StopFollowingThreadError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Mark a thread that user is following as read  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn update_thread_read_for_user(
    configuration: &configuration::Configuration,
    params: UpdateThreadReadForUserParams,
) -> Result<(), Error<UpdateThreadReadForUserError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;
    let thread_id = params.thread_id;
    let timestamp = params.timestamp;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/{thread_id}/read/{timestamp}",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id),
        thread_id = super::urlencode(thread_id),
        timestamp = super::urlencode(timestamp)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::PUT, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<UpdateThreadReadForUserError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Mark all threads that user is following as read  __Minimum server version__: 5.29  ##### Permissions Must be logged in as the user or have `edit_other_users` permission.
pub async fn update_threads_read_for_user(
    configuration: &configuration::Configuration,
    params: UpdateThreadsReadForUserParams,
) -> Result<(), Error<UpdateThreadsReadForUserError>> {
    let local_var_configuration = configuration;

    // unbox the parameters
    let user_id = params.user_id;
    let team_id = params.team_id;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/api/v4/users/{user_id}/teams/{team_id}/threads/read",
        local_var_configuration.base_path,
        user_id = super::urlencode(user_id),
        team_id = super::urlencode(team_id)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::PUT, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    if let Some(ref local_var_token) = local_var_configuration.bearer_access_token {
        local_var_req_builder = local_var_req_builder.bearer_auth(local_var_token.to_owned());
    };

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        Ok(())
    } else {
        let local_var_entity: Option<UpdateThreadsReadForUserError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}
